<template>
  <div class="w-full md:max-w-md">
    <div class="flex flex-col items-center">
      <p class="text-xl font-medium">Mitglied-Kommunikation löschen</p>
    </div>
    <br />
    <p class="text-center">
      Kommunikation {{ memberCommunication?.type.type }}
      {{ memberCommunication?.preferred ? "(bevorzugt)" : "" }} löschen?
    </p>
    <br />

    <div class="flex flex-row gap-2">
      <button
        primary
        type="submit"
        :disabled="status == 'loading' || status?.status == 'success'"
        @click="triggerDelete"
      >
        löschen
      </button>
      <Spinner v-if="status == 'loading'" class="my-auto" />
      <SuccessCheckmark v-else-if="status?.status == 'success'" />
      <FailureXMark v-else-if="status?.status == 'failed'" />
    </div>

    <div class="flex flex-row justify-end">
      <div class="flex flex-row gap-4 py-2">
        <button primary-outline @click="closeModal" :disabled="status == 'loading' || status?.status == 'success'">
          abbrechen
        </button>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { defineComponent } from "vue";
import { mapState, mapActions } from "pinia";
import { useModalStore } from "@/stores/modal";
import Spinner from "@/components/Spinner.vue";
import SuccessCheckmark from "@/components/SuccessCheckmark.vue";
import FailureXMark from "@/components/FailureXMark.vue";
import { useCommunicationStore } from "@/stores/admin/club/member/communication";
</script>

<script lang="ts">
export default defineComponent({
  data() {
    return {
      status: null as null | "loading" | { status: "success" | "failed"; reason?: string },
      timeout: undefined as any,
    };
  },
  computed: {
    ...mapState(useModalStore, ["data"]),
    ...mapState(useCommunicationStore, ["communications"]),
    memberCommunication() {
      return this.communications.find((m) => m.id == this.data);
    },
  },
  beforeUnmount() {
    try {
      clearTimeout(this.timeout);
    } catch (error) {}
  },
  methods: {
    ...mapActions(useModalStore, ["closeModal"]),
    ...mapActions(useCommunicationStore, ["deleteCommunication"]),
    triggerDelete() {
      this.status = "loading";
      this.deleteCommunication(this.data)
        .then(() => {
          this.status = { status: "success" };
          this.timeout = setTimeout(() => {
            this.closeModal();
          }, 1500);
        })
        .catch(() => {
          this.status = { status: "failed" };
        });
    },
  },
});
</script>
